## ----------------------------------------------------------------------------
# rishu_proxy.pl
#   里珠/PROXYのテスト
# -----------------------------------------------------------------------------
# 外部プロセスを使う方. 本体側里珠スクリプト.
# なゆきのさいしょの方ちょっとまねっこ.
# -----------------------------------------------------------------------------
# Mastering programed by YAMASHINA Hio
#
# Copyright 2002 YMIRLINK,Inc.
# -----------------------------------------------------------------------------
# $Id: rishu_proxy.pl,v 1.3 2002/11/04 14:15:05 hio Exp $
# -----------------------------------------------------------------------------
package main;
use strict;

# -----------------------------------------------------------------------------
# 移譲先設定
use lib 'lib';
my $pkg = 'Rishu::Proxy';

# -----------------------------------------------------------------------------
# 以下フレームワーク部

my ($on_load,$on_request,$on_unload)
  = eval "use $pkg;${pkg}->handler()";
$@ and die $@;

use vars qw(*on_load *on_request *on_unload);
*on_load    = $on_load;
*on_request = $on_request;
*on_unload  = $on_unload;

# てすと.
&test;
sub test
{
  my $res = $on_load->('./');
  print "<<< got (on_load) >>>\n$res---\n";
  $res or die "load method failed.";
  
  print "<wait>\n";
  my $in = '';
  while(<>)
  {
    chomp;
    $in .= "$_\r\n";
    if( $_ eq '' )
    {
      my $res = $on_request->($in);
      $in='';
      print "<<< got (on_request) >>>\n$res----\n";
      print "<wait>\n";
    }
  }
  $res = $on_unload->();
  print "<<< got (on_unload) >>>\n$res----\n";
}


1;

